#include <stdio.h>
#include <iostream>
#include "CImg.h"
using namespace std;
using namespace cimg_library;




//PRECONDITION: A valid .bmp file directory
void imageinput (float *&imageR,float *&imageG,float *&imageB, int x,int y, float *ptr)
{
    
    //inputting required pixel values to each array
    int i;
    int n=x*y;
    
    for (i=0;i<=(n-1);i++) {  //the red part
        (imageR[i])=*(ptr+i);
    }
    
    for (i=0;i<=(n-1);i++) {  //the green part
        (imageG[i])=*(ptr+n+i);
    }
    
    for (i=0;i<=(n-1);i++) {    // the blue part
        (imageB[i])=*(ptr+(2*n)+i);
    }
    return;
    
}

void imageoutput (float *&imageR, float *&imageG, float *&imageB, int noofrows, int noofcolumns, char status, char filedir[500])
{
    CImg <float> processed_image(noofcolumns,noofrows,1,3,0); /*creating an image "ciphered_image"  with
                                                              size noofrows*noofcolumns and 3 channels*/
    
    
    //creating the image out from the arrays
    char newdir[500];
    int i;
    for (i=0;i<=(noofrows*noofcolumns);i++) { //creating the red channel of all pixels
        *(processed_image.data()+i)=imageR[i];
        
    }
    
    for (i=0;i<=(noofrows*noofcolumns);i++) { //creating the green channel of all pixels
        *(processed_image.data()+(noofrows*noofcolumns)+i)=imageG[i];
        
    }
    
    for (i=0;i<=(noofrows*noofcolumns);i++) { //creating the blue channel of all pixels
        *(processed_image.data()+(2*(noofrows*noofcolumns))+i)=imageB[i];
        
    }
    
    CImgDisplay main_disp(processed_image,"Close window to save ");  /*create a window which displays the 
                                                                      ciphered
                                                                      image*/
    
    while (!main_disp.is_closed()) {
        main_disp.wait();
    }
    
    cout<<"Save ciphered file as.."<<endl;
    cout<<"(Enter file name with directory with '.bmp' extension) or press n to not save this file"<<endl;
    cin>>newdir;
    if (newdir[0]=='n') {
        cout<<"File not saved"<<endl;
        return;
    
    }
    
    bool verify = false;
    int j,k;
    for (j=0;j<=500;j++) {
        if ((newdir[j]=='.')&&(newdir[j+1]=='b')&&(newdir[j+2])=='m'&&(newdir[j+3]=='p')){ //verifying
            verify=true;
            break;
        }
        
    }
    if (verify) {
        
        for (k=(j+3);k>=0;k--) {   /* shifting all characters by 15 elements(build directory
                                    /Users/Imaad/Documents/CS_project/Debug) */
            newdir[k+15]=newdir[k];
            newdir[k]='0';
        }
    }
    if (!verify) {
        cout<<"The entered file/directory does not exist or the file is of an unsupported format"<<endl;
        cout<<"Please try again"<<endl;
    
    }
    
    int l;
    for (l=0;l<=13;l=l+3) {
        newdir[l]='.';
        newdir[l+1]='.';
        newdir[l+2]='/';
    }
    
    
    
    bool savestatus =processed_image.save(newdir);  //saves the processed image
    if (savestatus==true) {
        cout<<"Successfully saved image to "<<newdir<<endl;
        
    }
    return;
        }


class code
{
    unsigned char invo[4][4];
public:
    void invokey( )
    {
        unsigned char key22[2][2],key11[2][2],key12[2][2],key21[2][2],I[2][2];
        cout<<"please enter the key (it should contain 4 charachters)"<<endl;
        
        for ( int i=0;i<2;i++)
        {
            for ( int j=0;j<2;j++)
            {
                if(i==j)
                {
                    I[i][j]=1;
                }
                else
                {
                    I[i][j]=0;
                }
            }
        }
        
        for ( int i=0;i<2;i++)
        {
            for ( int j=0;j<2;j++)
            {
                cin>>key22[i][j];
                int temp;
                temp=-key22[i][j];
                key11[i][j]=temp;
            }
        }
        
        
        
        
        for ( int i=0;i<2;i++)
        {
            for ( int j=0;j<2;j++)
            {
                int temp1=I[i][j];
                int temp2=key11[i][j];
                key12[i][j]=temp1-temp2;
                key21[i][j]=temp1+temp2;
                
                
            }
        }
        
        
        
        for ( int i=0;i<4;i++)
        {
            for ( int j=0;j<4;j++)
            {
                if(i<2&&j<2)
                {
                    invo[i][j]=key11[i][j];
                }
                if(i>=2&&j<2)
                {
                    invo[i][j]=key21[i-2][j];
                }
                if(i<2&&j>=2)
                {
                    invo[i][j]=key12[i][j-2];
                }
                if(i>=2&&j>=2)
                {
                    invo[i][j]=key22[i-2][j-2];
                }
            }
        }
        
       /* for ( int i=0;i<4;i++)
        {                             involutary matrix output
            cout<<"\n";
            for ( int j=0;j<4;j++)
            {
                int temp=invo[i][j];
                cout<<invo[i][j]<<"-"<<temp<<" ";
                
            }
        }*/
        
        return ;
        
    }
    
    void cipher(float *  arrayR,float *  arrayB,float *  arrayG,int sizeofarray)
    {
        
        invokey();
        for (int l=0;l<sizeofarray/4;l++)
        {
            unsigned char tempR[4]={0,0,0,0};
            unsigned char tempB[4]={0,0,0,0};
            unsigned char tempG[4]={0,0,0,0};
            for ( int i=0;i<4;i++)
            {
                for ( int j=0;j<4;j++)
                {
                    tempR[i]+=arrayR[4*l+j]*invo[i][j];
                    tempB[i]+=arrayB[4*l+j]*invo[i][j];
                    tempG[i]+=arrayG[4*l+j]*invo[i][j];
                }
            }
            for ( int i=0;i<4;i++)
            {
                arrayR[4*l+i]=tempR[i];
                arrayB[4*l+i]=tempB[i];
                arrayG[4*l+i]=tempG[i];
                
            }
        }
        return;
    }
    
};




int main ()
{
    int j,k;
    char status;
    char filedir[500];
    cout<<"Welcome to ImageEncryptor/ImageDecryptor"<<endl;
    
    bool verify = false;
    
    while (verify==false||filedir[0]!='/') {  //looping until a .bmp file is given as input
    cout<<"Enter the directory of the file to be encrypted/decrypted (relative to Macintosh HD) or press q to quit"<<endl;
    cout<<"(Note that only .bmp files are supported at the moment)"<<endl;
    cin>>filedir;
    
        if (filedir[0]=='q') {  //exiting the program
            return 0;
        }
    //Algorithm for shifting characters of array filedir by 15 characters
    //Precondition: File is a .bmp file
    
    for (j=0;j<=500;j++) {
        if ((filedir[j]=='.')&&(filedir[j+1]=='b')&&(filedir[j+2])=='m'&&(filedir[j+3]=='p')){ //verifying
            verify=true;
            break;
        }
        
    }
    if (verify) {
        
        for (k=(j+3);k>=0;k--) {   /* shifting all characters by 15 elements(build directory
                                    /Users/Imaad/Documents/CS_project/Debug) */
            filedir[k+15]=filedir[k];
            filedir[k]='0';
        }
    }
    
    else {
        cout<<"The entered file/directory does not exist or the file is of an unsupported format"<<endl;
        cout<<"Please try again"<<endl;
        
        //insert same function here
    }
    }
    
    //Algorithm for adding the string required to go back to macintosh HD
    int l;
    for (l=0;l<=13;l=l+3) {
        filedir[l]='.';
        filedir[l+1]='.';
        filedir[l+2]='/';
    }
    
    
    
    CImg<float> image(filedir);   //Creating image "image" by reading input file
    CImgDisplay main_disp(image,"Close window to encrypt this image"); /*Creating a display window which displays
                                                              image and has
                                                              titlebar "Close window to continue" */
    
    while (!main_disp.is_closed()) { //loop which will ensure display is open till user manually closes it
        main_disp.wait ();
    }
    
    /*image.save("copy.bmp");*/  //creates and saves a copy of the image in the same directory
    
    
    int n=(image.width()*image.height()); //declaring variable which will be the size of all three arrays
    
    //Declaring arrays
    float *imageR=new float[n];
    float *imageG=new float[n];
    float *imageB=new float[n];
    
    cout<<"Press 'e' to encrypt image and 'd' to decrypt image"<<endl;
    cin>>status;
    
    if ((status!='e')&&(status!='d')) {
        do {  //asking user for option of encryption or decryption
            cout<<"Invalid input. Please try again"<<endl;
            cout<<"Press 'e' to encrypt image and 'd' to decrypt image"<<endl;
            cin>>status;
        }
        
        
        while (!(status=='e')&&!(status=='d'));
    }
    
    //Converting the image into array
    imageinput (imageR, imageG, imageB, image.width(), image.height(),image.data());
    code object;
    object.cipher(imageR, imageG, imageB, image.width()*image.height());
    
    /*if (status=='e') {
        imageencrypt(imageR,image.width()*image.height());
        imageencrypt(imageG,image.width()*image.height());
        imageencrypt(imageB,image.width()*image.height());
    }*/
    
    /*else {
        imagedecrypt (imageR,image.width()*image.height());
        imagedecrypt (imageG,image.width()*image.height());
        imagedecrypt (imageB,image.width()*image.height());
    }*/
    
    
    //converting ciphered/deciphered arrays into images and outputting it
    
    imageoutput(imageR, imageG, imageB, image.height(), image.width(), status, filedir);
    
    char rerun='0';
    while (rerun!='r'&&rerun!='q'){
        
    
    cout<<"Press q and hit return to quit or r to encrypt/decrypt another image"<<endl;
    cin>>rerun;
    }
    
    if (rerun=='q') {
        return 0;
    }
    
    else {
        cout<<'\n';
        main ();
    }
}

/*int i,j,k;
for (i=0;i<=(size_of_array-1);i++) {  //coverting each element to its binary
    array[i]=binary(array[i]);
} */


